<?php

if ( ! defined( 'ABSPATH' ) ) { 
    exit; // Exit if accessed directly
}

add_action('admin_menu', 'wpcd_register_submenu_page');

function wpcd_register_submenu_page() {
    add_submenu_page( 'woocommerce', __('Product Tag Discount'), __('Product Tag Discount'), 'manage_options', 'wpcd-Tag-discount', 'wpcd_product_Tag_discount' ); 
}

function wpcd_product_Tag_discount() {

    global $wpdb;
    
    echo '<h3>' . __('Product Tag Discount') . '</h3>';
        
    $strTag = 'SELECT tt.term_id t_id, tt.term_taxonomy_id tt_id, t.name name, tt.parent parent '
            . ' FROM ' . $wpdb->prefix . 'terms t, '
            . $wpdb->prefix . 'term_taxonomy tt '
            . ' WHERE tt.term_id = t.term_id'
            . ' AND tt.taxonomy = "product_tag"';
    $arrtagegories = $wpdb->get_results($strTag);
    
    $arrProcessedtag = array();    
    foreach($arrtagegories AS $key => $arrVal) {
        $strtagName = wpcd_get_term_parents($arrVal->t_id, 'product_tag');
        $arrProcessedtag[$arrVal->t_id]['name'] = substr($strtagName, 0, strlen($strtagName) - 3);
        $arrProcessedtag[$arrVal->t_id]['breadcrumb'] = (!empty($arrProcessedtag[$arrVal->parent]['name'])?$arrProcessedtag[$arrVal->parent]['name'] . ' >> ' : '') . $arrVal->name;
        if($arrVal->parent != 0) {
            $arrProcessedtag[$arrVal->parent]['child'][] = $arrVal->t_id;
            $arrProcessedtag[$arrVal->t_id]['isChild'] = 1;
        } else {
            $arrProcessedtag[$arrVal->t_id]['isChild'] = 0;
        }
    }
    
    // Get Tag discount
    $strTag = get_option('wpcd_Tag_discount');
    $arrtagDiscount = unserialize($strTag);
    
    ?><form enctype="multipart/form-data" method="POST" style="width:60%;float:left;">
        <div class="postbox wc-metaboxes-wrapper" style="width:90%">
            <table style="padding:10px">
                <tbody>
                    <tr>
                        <th>Tag</th>
                        <th>Discount type</th>
                        <th>Amount</th>
                        <th>Apply</th>
                    </tr><?php
                    foreach($arrProcessedtag AS $key => $arrVal) {
                        
                        if(!$arrVal['isChild']) {
                            ?><tr class="trwcpd<?php echo $key;?>">
							
							<td style="padding:5px;"  id="tdsel">
                                <label for="txttagAmount_<?php echo $key;?>"><?php echo $arrProcessedtag[$key]['name']; ?></label>
                            </td>
							
                            <td style="padding:5px;">
                                <select name="seltag_<?php echo $key;?>" class="type">
                                    <option value="Fixed Amount"><?php _e('Fixed Amount');?></option>
                                    <option value="% of Price"><?php _e('% of Price');?></option>
                                </select>
                            </td>
							
                            <td style="padding:5px;">
                                <input type='text' data-row_id="<?php echo $key;?>" class="amount" size='12' name="txttagAmount_<?php echo $key;?>" id="txttagAmount_<?php echo $key;?>" placeholder="Enter Amount" value="<?php echo isset($arrtagDiscount[$key]['value'])?$arrtagDiscount[$key]['value']:'';?>"/>
                                <?php echo ' ( ' . get_woocommerce_currency_symbol() . ' )';?>
                            </td>
							
                            <td style="padding:5px;">
                                <input type='checkbox' data-row_id="<?php echo $key;?>" class="active" name="chkActive_<?php echo $key;?>" id="chkActive_<?php echo $key;?>" placeholder="Enter Amount" value="Y" <?php echo isset($arrtagDiscount[$key]['isActive']) && $arrtagDiscount[$key]['isActive'] == 'true'?' checked="checked"':'';?>/>
                            </td>
							
                            <td class="loader" style="display:none;">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/hourglass.gif';?>" style="height:30px;"/>
                            </td>
							
                            <td class="complete" style="display:none;">
                                <img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/complete.png';?>" style="height:30px;"/>
                            </td>
							
							</tr><?php
                        }
                        if(!empty($arrVal['child'])) {
                            foreach($arrVal['child'] AS $keyTemp => $childId) {
                                ?><tr class="trwcpd<?php echo $childId;?>"><td style="padding:5px;">
                                    <label for="txttagAmount_<?php echo $childId;?>"><?php echo $arrProcessedtag[$childId]['name']; ?></label>
                                </td>
                                <td style="padding:5px;">
                                    <select name="seltag_<?php echo $childId;?>" class="type">
                                        <option value="Fixed Amount"><?php _e('Fixed Amount');?></option>
                                        <option value="% of Price" disabled><?php _e('% of Price');?></option>
                                    </select>
                                </td>
                                <td style="padding:5px;">
                                    <input type='text' data-row_id="<?php echo $childId;?>" class="amount" size='12' name="txttagAmount_<?php echo $childId;?>" id="txttagAmount_<?php echo $childId;?>" placeholder="Enter Amount" value="<?php echo isset($arrtagDiscount[$childId]['value'])?$arrtagDiscount[$childId]['value']:'';?>"/>
                                    <?php echo ' ( ' . get_woocommerce_currency_symbol() . ' )';?>
                                </td>
                                <td style="padding:5px;">
                                    <input type='checkbox' class="active" name="chkActive_<?php echo $childId;?>" id="chkActive_<?php echo $childId;?>" value="Y" data-row_id="<?php echo $childId;?>" <?php echo isset($arrtagDiscount[$childId]['isActive']) && $arrtagDiscount[$childId]['isActive'] == 'true'?' checked="checked"':'';?>/>
                                </td>
                                <td class="loader" style="display:none;">
                                    <img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/hourglass.gif';?>" style="height:30px;"/>
                                </td>
                                <td class="complete" style="display:none;">
                                    <img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/complete.png';?>" style="height:30px;"/>
                                </td></tr><?php
                            }
                        } 
                    }
                ?></tbody>
            </table>
        </div>
    </form>
    <div>
        <a href="http://www.wooextend.com/product/woo-product-Tag-discount-pro/" target="_blank">
            <img src="<?php echo plugin_dir_url( __FILE__ ) . 'assets/images/banner.jpg';?>"/>
        </a>
    </div><?php
}

add_action( 'admin_enqueue_scripts', 'load_custom_wp_admin_style' );
function load_custom_wp_admin_style() {
    wp_register_script( 'discount_admin_js', plugin_dir_url( __FILE__ ) . 'assets/js/tag-discount.js', false, '1.0.0' );
    wp_enqueue_script( 'discount_admin_js' );
    // Localize the script
    $translation_array = array(
        'admin_url' => admin_url('admin-ajax.php')
    );
    wp_localize_script( 'discount_admin_js', 'wpcd_obj', $translation_array );
}

add_action( 'wp_ajax_wpcd_calculate_discount', 'wpcd_save_discount' );
add_action( 'wp_ajax_nopriv_wpcd_calculate_discount', 'wpcd_save_discount' );

function wpcd_save_discount() {

    global $wpdb;

    // Get existing saved discounts
    $strTagPrice = get_option('wpcd_Tag_discount');
    $arrTagPrice = unserialize($strTagPrice);

    $reqtagId = $_POST['tag_id'];
    if(isset($arrTagPrice[$reqtagId]) && !empty($arrTagPrice[$reqtagId])) {
        $arrSelectedtag = $arrTagPrice[$reqtagId];
    } else {
        $arrSelectedtag = array('type' => 'Fixed Amount', 'value' => 0, 'isActive' => 'false');
    }

    $arrTagPrice[$reqtagId] = array('type' => 'Fixed Amount', 'value' => $_POST['amount'], 'isActive' => $_POST['active']);
    
    // check if existing and requested both status are inactive, then no need to update product prices
    if($_POST['active'] == 'false' && ($arrSelectedtag['isActive'] == 'false' || empty($arrSelectedtag['isActive']))) {
        update_option('wpcd_Tag_discount', serialize($arrTagPrice));
        die();
    }

    // check if we need to remove applied discount
    if($_POST['active'] == 'false' && $arrSelectedtag['isActive'] == 'true') {

        // Get all products in Tag
        $strTag = 'SELECT tr.object_id product_id, pmWpcdtags.meta_value selected_tags, pmPrice.meta_value regular_price'
                    . ' FROM ' . $wpdb->prefix . 'terms t '
                    . ' LEFT JOIN ' . $wpdb->prefix . 'term_taxonomy tt ON (tt.term_id = t.term_id)'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'term_relationships tr ON (tr.term_taxonomy_id = tt.term_taxonomy_id)'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'postmeta pmPrice ON (tr.object_id = pmPrice.post_id AND pmPrice.meta_key = "_regular_price")'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'postmeta pmWpcdtags ON (tr.object_id = pmWpcdtags.post_id AND pmWpcdtags.meta_key = "_wpcd_tags")'
                    . ' WHERE tt.taxonomy = "product_tag"'
                    . ' AND t.term_id = "' . $reqtagId . '"';
        $arrtagegories = $wpdb->get_results($strTag);

        // Loop for each product
        foreach($arrtagegories AS $keyPro => $arrPro) {

            $objProduct = new WC_Product( $arrPro->product_id );
            $objChildProduct = $objProduct->get_child( $arrPro->product_id );

            if($objChildProduct->product_type == 'simple') {
                
                // Get all tagegories that product belongs to
                $arrtags = array();
                $strtags = $arrPro->selected_tags;
                if(isset($strtags) && !empty($strtags)) {
                    $arrtags = explode(',', $strtags);
                }    
                $key = array_search($reqtagId, $arrtags); 
                unset($arrtags[$key]);           
                update_post_meta($objChildProduct->id, '_wpcd_tags', implode(',', array_unique($arrtags)));

                if(!empty($arrtags)) {

                    // Update prices
                    $fltRegularPrice = (float)$arrPro->regular_price;
                    $discountAmount = get_discount_amount($arrTagPrice, $arrtags);
                    $newPrice = $fltRegularPrice - $discountAmount;

                    update_post_meta($objChildProduct->id, '_price', $newPrice); 
                    update_post_meta($objChildProduct->id, '_sale_price', $newPrice);
                } else {
                    // Delete wpcd discount
                    delete_post_meta($objChildProduct->id, '_sale_price');
                    delete_post_meta($objChildProduct->id, '_wpcd_tags');
                    // Restore old discounted price
                    $strUpdateKey = "UPDATE {$wpdb->prefix}postmeta SET meta_key = '_sale_price' WHERE meta_key = '_wpcd_sale_price'
                        AND post_id = {$objChildProduct->id}";
                    $wpdb->query($strUpdateKey);

                    $fltRegularPrice = $arrPro->regular_price;
                    $fltSalePrice = get_post_meta($objChildProduct->id, '_sale_price', true);

                    $effectivePrice = (float)(isset($fltSalePrice) && !empty($fltSalePrice)?$fltSalePrice:$fltRegularPrice);
                    update_post_meta($objChildProduct->id, '_price', $effectivePrice); 
                }              
            } else {

                $strVariations = "SELECT p.ID variation_id
                 FROM {$wpdb->prefix}posts p
                 WHERE p.post_type='product_variation' AND p.post_parent = '{$arrPro->product_id}'";
                $arrVariations = $wpdb->get_results($strVariations, ARRAY_A);

                // Loop for each variation 
                foreach($arrVariations AS $keVar => $arrVar) {

                    // Get all tagegories that product belongs to
                    $arrtags = array();
                    $strtags = $arrPro->selected_tags;
                    if(isset($strtags) && !empty($strtags)) {
                        $arrtags = explode(',', $strtags);
                    }    
                    $key = array_search($reqtagId, $arrtags); 
                    unset($arrtags[$key]);           
                    update_post_meta($arrVar['variation_id'], '_wpcd_tags', implode(',', array_unique($arrtags)));

                    if(!empty($arrtags)) {

                        // Update prices
                        $fltRegularPrice = (float)get_post_meta($arrVar['variation_id'], '_regular_price', true);
                        $discountAmount = get_discount_amount($arrTagPrice, $arrtags);
                        $newPrice = $fltRegularPrice - $discountAmount;

                        update_post_meta($arrVar['variation_id'], '_price', $newPrice); 
                        update_post_meta($arrVar['variation_id'], '_sale_price', $newPrice);
                    } else {

                        // Delete wpcd discount
                        delete_post_meta($arrVar['variation_id'], '_sale_price');
                        delete_post_meta($arrVar['variation_id'], '_wpcd_tags');
                        // Restore old discounted price
                        $strUpdateKey = "UPDATE {$wpdb->prefix}postmeta SET meta_key = '_sale_price' WHERE meta_key = '_wpcd_sale_price'
                            AND post_id = {$arrVar['variation_id']}";
                        $wpdb->query($strUpdateKey);

                        $fltRegularPrice = get_post_meta($arrVar['variation_id'], '_regular_price', true);
                        $fltSalePrice = get_post_meta($arrVar['variation_id'], '_sale_price', true);

                        $effectivePrice = (float)(isset($fltSalePrice) && !empty($fltSalePrice)?$fltSalePrice:$fltRegularPrice);
                        update_post_meta($arrVar['variation_id'], '_price', $effectivePrice);
                    }
                }
            }
        }
        $arrTagPrice[$reqtagId] = array('type' => 'Fixed Amount', 'value' => $_POST['amount'], 'isActive' => $_POST['active']);
        update_option('wpcd_Tag_discount', serialize($arrTagPrice));
        die();
    }

    // check if we need to apply discount
    if($_POST['active'] == 'true') {

        // Get all products in Tag
        $strTag = 'SELECT tr.object_id product_id, pmWpcdtags.meta_value selected_tags, pmPrice.meta_value regular_price'
                    . ' FROM ' . $wpdb->prefix . 'terms t '
                    . ' LEFT JOIN ' . $wpdb->prefix . 'term_taxonomy tt ON (tt.term_id = t.term_id)'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'term_relationships tr ON (tr.term_taxonomy_id = tt.term_taxonomy_id)'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'postmeta pmPrice ON (tr.object_id = pmPrice.post_id AND pmPrice.meta_key = "_regular_price")'
                    . ' LEFT JOIN ' . $wpdb->prefix . 'postmeta pmWpcdtags ON (tr.object_id = pmWpcdtags.post_id AND pmWpcdtags.meta_key = "_wpcd_tags")'
                    . ' WHERE tt.taxonomy = "product_tag"'
                    . ' AND t.term_id = "' . $reqtagId . '"';
        $arrtagegories = $wpdb->get_results($strTag);
        // Loop for each product
        foreach($arrtagegories AS $keyPro => $arrPro) {

            $objProduct = new WC_Product( $arrPro->product_id );
            $objChildProduct = $objProduct->get_child( $arrPro->product_id );

            if($objChildProduct->product_type == 'simple') {
                
                // Backup existing discount price if not saved
                $strGetKey = "SELECT * FROM {$wpdb->prefix}postmeta WHERE meta_key = '_wpcd_sale_price'
                    AND post_id = {$objChildProduct->id}";
                $arrKey = $wpdb->get_results($strGetKey);

                if(empty($arrKey)) {
                    $strUpdateKey = "UPDATE {$wpdb->prefix}postmeta SET meta_key = '_wpcd_sale_price' WHERE meta_key = '_sale_price'
                        AND post_id = {$objChildProduct->id}";
                    if(!$wpdb->query($strUpdateKey)) {
                        update_post_meta($objChildProduct->id, '_wpcd_sale_price', $newPrice);
                    }
                }
                
                // Get all tagegories that product belongs to
                $arrtags = array();
                $strtags = $arrPro->selected_tags;
                if(isset($strtags) && !empty($strtags)) {
                    $arrtags = explode(',', $strtags);
                }
                $arrtags[] = $reqtagId;                
                update_post_meta($objChildProduct->id, '_wpcd_tags', implode(',', array_unique($arrtags)));

                // Update prices
                $fltRegularPrice = (float)$arrPro->regular_price;
                $discountAmount = get_discount_amount($arrTagPrice, $arrtags);
                $newPrice = $fltRegularPrice - $discountAmount;

                update_post_meta($objChildProduct->id, '_price', $newPrice); 
                update_post_meta($objChildProduct->id, '_sale_price', $newPrice);
            } else {

                $strVariations = "SELECT p.ID variation_id, pmPrice.meta_value regular_price, wpcdSalePrice.meta_value wpcd_sale_price
                 FROM {$wpdb->prefix}posts p
                 LEFT JOIN {$wpdb->prefix}postmeta pmPrice ON (p.ID = pmPrice.post_id AND pmPrice.meta_key = '_regular_price')
                 LEFT JOIN {$wpdb->prefix}postmeta wpcdSalePrice ON (p.ID = wpcdSalePrice.post_id AND wpcdSalePrice.meta_key = '_wpcd_sale_price')
                 WHERE p.post_type='product_variation' AND p.post_parent = '{$arrPro->product_id}'";
                $arrVariations = $wpdb->get_results($strVariations, ARRAY_A);

                // Loop for each variation 
                foreach($arrVariations AS $keVar => $arrVar) {

                    // Backup existing discount price if not saved
                    if(empty($arrVar['wpcd_sale_price'])) {
                        $strUpdateKey = "UPDATE {$wpdb->prefix}postmeta SET meta_key = '_wpcd_sale_price' WHERE meta_key = '_sale_price'
                            AND post_id = {$arrVar['variation_id']}";
                        if(!$wpdb->query($strUpdateKey)) {
                            update_post_meta($objChildProduct->id, '_wpcd_sale_price', $newPrice);
                        }
                    }

                    // Get all tagegories that product belongs to
                    $arrtags = array();
                    $strtags = $arrPro->selected_tags;
                    if(isset($strtags) && !empty($strtags)) {
                        $arrtags = explode(',', $strtags);
                    }
                    $arrtags[] = $reqtagId;                
                    update_post_meta($arrVar['variation_id'], '_wpcd_tags', implode(',', array_unique($arrtags)));

                    // Update prices
                    $fltRegularPrice = $arrVar['regular_price'];
                    $discountAmount = get_discount_amount($arrTagPrice, $arrtags);
                    $newPrice = $fltRegularPrice - $discountAmount;

                    update_post_meta($arrVar['variation_id'], '_price', $newPrice); 
                    update_post_meta($arrVar['variation_id'], '_sale_price', $newPrice);
                }
            }
        }
        $arrTagPrice[$reqtagId] = array('type' => 'Fixed Amount', 'value' => $_POST['amount'], 'isActive' => $_POST['active']);
        update_option('wpcd_Tag_discount', serialize($arrTagPrice));
        die();
    }
}

function get_discount_amount($arrtagDetails, $arrSelectedtags) {

    $arrSelectedAmount = array();
    
    foreach($arrtagDetails AS $key => $arrVal) {

        if(isset($arrVal['isActive']) && !empty($arrVal['isActive']) && $arrVal['isActive'] == 'true' && in_array($key, $arrSelectedtags)) {
            $arrSelectedAmount[] = $arrVal['value'];
        }
    }
    
    return count($arrSelectedAmount) > 1?max($arrSelectedAmount):$arrSelectedAmount[0];
}

add_filter( 'woocommerce_get_variation_prices_hash', 'add_user_id_to_woocommerce_get_variation_prices_hash' );

function add_user_id_to_woocommerce_get_variation_prices_hash( $hash ) {
  $hash[] = rand();
  return $hash;
}

function wpcd_get_term_parents( $id, $taxonomy, $link = false, $separator = ' >> ', $nicename = false, $visited = array() ) {
    $chain = '';
    $parent = &get_term( $id, $taxonomy );
    if ( is_wp_error( $parent ) )
            return $parent;

    if ( $nicename ) {
            $name = $parent->slug;
    } else {
            $name = $parent->name;
    }

    if ( $parent->parent && ( $parent->parent != $parent->term_id ) && !in_array( $parent->parent, $visited ) ) {
            $visited[] = $parent->parent;
            $chain .= wpcd_get_term_parents( $parent->parent, $taxonomy, $link, $separator, $nicename, $visited );
    }

    if ( $link ) {
            $chain .= '<a href="' . get_term_link( $parent, $taxonomy ) . '" title="' . esc_attr( sprintf( _e( "View all posts in %s" ), $parent->name ) ) . '">'.$parent->name.'</a>' . $separator;
    } else {
            $chain .= $name.$separator;
    }
    return $chain;
}


?>